﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace LoadedToTheGills
{
    /// <summary>
    /// Логика взаимодействия для Menu.xaml
    /// </summary>
    public partial class Menu : Window
    {
        gr671_kyaaEntities Entity = new gr671_kyaaEntities();
       // public List<Users> userList { get; set; } 
        public String LabelText { get; set; }
        
        public Menu()
        {
            InitializeComponent();
            
        }

        private void Window_Loaded (object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            var users = Entity.Users.ToList();
            var leads = Entity.Lead.ToList();
            var _leads = Entity.Lead.ToList().Where(x => x.StatusLead == "Неактивный");

            usersBox.ItemsSource = users;
            leadBox.ItemsSource = _leads;

            leadGrid.ItemsSource = leads.ToList();

            txtBoxCallDate.Text = DateTime.Now.ToString();
            txtBoxCallDate.IsReadOnly = true;
            lblName.Content = LabelText;
            var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
            int id_ = idUser_;
            txtBoxUser.Text = Convert.ToString(id_);

            if (txtBoxUser.Text == "0")
            {
                callGrid.ItemsSource = calls.ToList();
                btnAdd.IsEnabled = false;
                btnDelete.IsEnabled = false;
                
            }

            if (txtBoxUser.Text != "0")
            {
                txtBoxUser.IsReadOnly = true;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
            }

            
        }

        private void BtnDelete_Click(object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            int num = (callGrid.SelectedItem as Call).idCall;
            var idRow = Entity.Call.Where(delete => delete.idCall == num).FirstOrDefault();
            var idLead_ = Entity.Call.Where(id => id.idCall == num).Select(Call => Call.idLead).FirstOrDefault();
            int idLead__ = Convert.ToInt32(idLead_);
            var statusLead = Entity.Lead.Where(id => id.idLead == idLead__).Select(Status => Status.StatusLead).FirstOrDefault();
            if(Convert.ToString(statusLead) == "Неактивный")
            {
                MessageBox.Show("Вы не можете удалить неактивный лид");
                return;
            }
            else
            {
                Entity.Call.Remove(idRow);
                Entity.SaveChanges();
            }
            if ((String)lblName.Content == "Username")
            {
                callGrid.ItemsSource = calls;
            }
            else 
            {
                var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
                int id_ = idUser_;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
            }


        }

        private void BtnAdd_Click(object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();

            if(txtBoxCallDate.Text == "" || leadBox.Text == "" || txtBoxLong.Text == "" || txtBoxUser.Text == "")
            {
                MessageBox.Show("Заполнены не все данные");
                return;
            }
            else
            {
                Call call = new Call()
                {
                    CallDate = Convert.ToDateTime(txtBoxCallDate.Text),
                    LongCall = Convert.ToInt32(txtBoxLong.Text),
                    idLead = Convert.ToInt32(leadBox.Text),
                    idUser = Convert.ToInt32(txtBoxUser.Text)
                };
                
                Entity.Call.Add(call);
                int LeadId = (leadBox.SelectedItem as Lead).idLead;
                var NewStatus = Entity.Lead.Where(x => x.idLead == LeadId).FirstOrDefault();
                NewStatus.IsCalled = true;
                Entity.SaveChanges();
                var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
                int id_ = idUser_;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);

            }
        }


        private void UsersBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            int num = (usersBox.SelectedItem as Users).idUser;
            callGrid.ItemsSource = calls.Where(id => id.idUser == num);
            string num_ = Convert.ToString(num);
            if(txtBoxUser.Text != num_)
            {
                btnAdd.IsEnabled = false;
                btnDelete.IsEnabled = false;
                callButton.IsEnabled = false;
               
            }
            if(txtBoxUser.Text == num_)
            {
                btnAdd.IsEnabled = true;
                btnDelete.IsEnabled = true;
                callButton.IsEnabled = true;
            }
        }
  
        private void LeadButton_Click(object sender, RoutedEventArgs e)
        {
            LeadWindow lw = new LeadWindow();
            int _num;
            if (leadGrid.SelectedItem == null)
            {
                MessageBox.Show("Не выбран лид");
                return;
            }
            else
            {
                _num = (leadGrid.SelectedItem as Lead).idLead;
                lw.IdLabel = _num;
                lw.LogLabel = (String)lblName.Content;
                lw.Show();
                this.Hide();
            }
        }

        private void CallButton_Click(object sender, RoutedEventArgs e)
        {
            CallWindow cw = new CallWindow();
            int num;
            if (callGrid.SelectedItem == null)
            {
                MessageBox.Show("Не выбран звонок");
                return;
            }
            else
            {
                num = (callGrid.SelectedItem as Call).idCall;
                cw.IdLabel = num;
                cw.Show();
                this.Hide();
            }
        }

        
    }
}
